## oce 0.12

=== CMakeLists.txt ===
# REQUIREMENTS: this script needs CMake 2.8 or higher. Downloads are available at http://www.cmake.org

# How to build OCE using CMake under Unix (Linux, Darwin etc.)?
# 1. Copy this file, as-is, to the top-level OCE folder
# 2. Make a build directory somewhere outside the OCE source tree
# 3. cmake "relative/path/to/OCE"
# 4. make
# 5. make install (or sudo make install)

# How to build OCE using CMake under Windows (Linux, Darwin etc.)?
# 1. Copy this file, as-is, to the top-level folder
# 2. Launch the cmake-gui, and select the top-level folder
# 3. You can choose whatever you want as an install directory
# 4. Click 'Configure'
# 5. Choose your generator
# 6. When configure is achived, you can change the variable with a red background
# 7. Click 'Generate'
# 8. From your IDE, open the generated makefile and run the compilation.

PROJECT(OCE)

SET(OCE_VERSION_MAJOR 0)
SET(OCE_VERSION_MINOR 12)
# OCE_VERSION_PATCH is used for bugfixes releases only
# (uncomment following line)
#SET(OCE_VERSION_PATCH 0)
#  Empty for official releases, set to -dev, -rc1, etc for development releases
SET(OCE_VERSION_DEVEL)

# bugfix release: add ${OCE_VERSION_PATCH} to OCE_VERSION
SET(OCE_VERSION ${OCE_VERSION_MAJOR}.${OCE_VERSION_MINOR}${OCE_VERSION_DEVEL})

SET(OCE_ABI_SOVERSION 6)
SET(OCE_ABI_VERSION ${OCE_ABI_SOVERSION}.0.0)

# Set the minimum version of cmake required to 2.6
CMAKE_MINIMUM_REQUIRED( VERSION 2.6 )

# Define helper macro OPTION_WITH_DEFAULT
MACRO( OPTION_WITH_DEFAULT OPTION_NAME OPTION_STRING OPTION_DEFAULT )
	IF( NOT DEFINED ${OPTION_NAME} )
		SET( ${OPTION_NAME} ${OPTION_DEFAULT} )
	ENDIF( NOT DEFINED ${OPTION_NAME} )
	OPTION( ${OPTION_NAME} "${OPTION_STRING}" ${${OPTION_NAME}} )
ENDMACRO( OPTION_WITH_DEFAULT OPTION_NAME OPTION_STRING OPTION_DEFAULT )

############################
# Check 32/64 bit platform #
############################
IF (${CMAKE_SIZEOF_VOID_P} MATCHES "8") # It is 64bit, otherwise 32 bit systems match 4
	ADD_DEFINITIONS(-D_OCC64)
	SET(BIT 64)
ELSE (${CMAKE_SIZEOF_VOID_P} MATCHES "8")
	SET(BIT 32)
ENDIF(${CMAKE_SIZEOF_VOID_P} MATCHES "8")

MESSAGE(STATUS "Build ${BIT}bit")

IF (NOT MSVC)
	IF( NOT DEFINED ${PROJECT_NAME}_BUILD_TYPE )
		SET( ${PROJECT_NAME}_BUILD_TYPE "Release" CACHE STRING "Build type" ) # By default set release build
	ENDIF( NOT DEFINED ${PROJECT_NAME}_BUILD_TYPE )
	SET( CMAKE_BUILD_TYPE ${${PROJECT_NAME}_BUILD_TYPE} CACHE INTERNAL "Build type,
		immutable" FORCE )
ENDIF(NOT MSVC)

IF(CMAKE_BUILD_TOOL STREQUAL "nmake")
	SET(NMAKE TRUE)
ENDIF(CMAKE_BUILD_TOOL STREQUAL "nmake")

IF(MSVC)
	OPTION_WITH_DEFAULT( ${PROJECT_NAME}_INSTALL_PDB_FILES "Install PDB files (debug informations)" ON )
ENDIF(MSVC)

IF(MSVC)
	OPTION_WITH_DEFAULT( ${PROJECT_NAME}_USE_BUNDLE "Use OCE Windows Bundle that has been built and installed" OFF )
	OPTION_WITH_DEFAULT( ${PROJECT_NAME}_USE_BUNDLE_SOURCE "Use OCE Windows Bundle source and incorporate into current project" OFF )
ENDIF(MSVC)

IF(BORLAND)
	OPTION_WITH_DEFAULT( ${PROJECT_NAME}_INSTALL_TDS_FILES "Instal TDS files (debug informations)" ON )
ENDIF(BORLAND)

IF(${PROJECT_NAME}_USE_BUNDLE OR ${PROJECT_NAME}_USE_BUNDLE_SOURCE)
	OPTION_WITH_DEFAULT( ${PROJECT_NAME}_BUNDLE_AUTOINSTALL "Autoinstall bundle DLLs" ON )
	MARK_AS_ADVANCED(${PROJECT_NAME}_BUNDLE_AUTOINSTALL)
ENDIF(${PROJECT_NAME}_USE_BUNDLE OR ${PROJECT_NAME}_USE_BUNDLE_SOURCE)

IF ((MSVC AND NOT NMAKE) OR CMAKE_COMPILER_IS_GNUCXX)
	SET(${PROJECT_NAME}_COMPILER_SUPPORTS_PCH TRUE)
	IF(MSVC)
		OPTION_WITH_DEFAULT( ${PROJECT_NAME}_USE_PCH "Use Precompiled Headers" ON )
	ELSE()
		OPTION_WITH_DEFAULT( ${PROJECT_NAME}_USE_PCH "Use Precompiled Headers" OFF )	
	ENDIF()
	MARK_AS_ADVANCED(${PROJECT_NAME}_USE_PCH)
ENDIF((MSVC AND NOT NMAKE) OR CMAKE_COMPILER_IS_GNUCXX)

OPTION_WITH_DEFAULT( ${PROJECT_NAME}_BUILD_SHARED_LIB "Build shared ${PROJECT_NAME} libs" ON )
IF(NOT MSVC)
	OPTION_WITH_DEFAULT( ${PROJECT_NAME}_DISABLE_X11 "Disable components requiring X11 support" OFF )
	IF(NOT APPLE AND NOT WIN32)
		MARK_AS_ADVANCED(${PROJECT_NAME}_DISABLE_X11)
	ENDIF(NOT APPLE AND NOT WIN32)
ENDIF(NOT MSVC)
OPTION_WITH_DEFAULT( ${PROJECT_NAME}_MODEL "Build model components" ON )
OPTION_WITH_DEFAULT( ${PROJECT_NAME}_OCAF "Build application framework" ON )
OPTION_WITH_DEFAULT( ${PROJECT_NAME}_DATAEXCHANGE "Build data exchange" ON )
OPTION_WITH_DEFAULT( ${PROJECT_NAME}_DRAW "Build test harness \(DRAW\)" OFF )
OPTION_WITH_DEFAULT( ${PROJECT_NAME}_VISUALISATION "Build visualisation component" ON )
OPTION_WITH_DEFAULT( ${PROJECT_NAME}_WITH_GL2PS "Build with GL2PS" OFF )
OPTION_WITH_DEFAULT( ${PROJECT_NAME}_WITH_FREEIMAGE "Build with FreeImage" OFF )
OPTION_WITH_DEFAULT( ${PROJECT_NAME}_EXTRA_WARNINGS "Enable Maximum Warnings Level" OFF )
MARK_AS_ADVANCED(${PROJECT_NAME}_EXTRA_WARNINGS)
IF( NOT "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" LESS 2.8 )
	OPTION_WITH_DEFAULT( ${PROJECT_NAME}_TESTING "Enable unittesting framework" OFF )
	MARK_AS_ADVANCED(${PROJECT_NAME}_TESTING)
ENDIF( NOT "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" LESS 2.8 )
OPTION_WITH_DEFAULT( ${PROJECT_NAME}_ADD_HEADERS "Add headers to project files" OFF )
MARK_AS_ADVANCED(${PROJECT_NAME}_ADD_HEADERS)
OPTION_WITH_DEFAULT( ${PROJECT_NAME}_DISABLE_BSPLINE_MESHER "Disable BSpline Mesher" OFF )
MARK_AS_ADVANCED(${PROJECT_NAME}_DISABLE_BSPLINE_MESHER)
IF(APPLE)
  OPTION_WITH_DEFAULT( ${PROJECT_NAME}_OSX_USE_COCOA "Use native OSX Cocoa backend" ON )
ENDIF(APPLE)
IF (NOT WIN32)
  OPTION_WITH_DEFAULT( ${PROJECT_NAME}_RPATH_FILTER_SYSTEM_PATHS "Filter out system paths from RPATH" ON )
  MARK_AS_ADVANCED(${PROJECT_NAME}_RPATH_FILTER_SYSTEM_PATHS)
ENDIF (NOT WIN32)

#
# By default, OSX uses X11 OpenGl implementation
#
IF (APPLE)
  IF (NOT ${PROJECT_NAME}_OSX_USE_COCOA)
    SET(MACOSX_USE_GLX TRUE)
  ENDIF(NOT ${PROJECT_NAME}_OSX_USE_COCOA)
ENDIF(APPLE)
# The default for the DEB define is ON for all the platforms , in debug mode.
# In MSVC it is not desirable to have it ON by default, since users must 
# compile/use the OCE debug libraries to build it's own programs in DEBUG mode.
# DEB should be enabled by developers only, in this case
IF ((MSVC OR BORLAND) AND CMAKE_CONFIGURATION_TYPES)
  SET (DEB_DEFAULT "OFF")
ELSE ()
   SET (DEB_DEFAULT "ON")
ENDIF ((MSVC OR BORLAND) AND CMAKE_CONFIGURATION_TYPES)

OPTION_WITH_DEFAULT( ${PROJECT_NAME}_ENABLE_DEB_FLAG "Enables DEB define in debug configuration" ${DEB_DEFAULT} )
MARK_AS_ADVANCED(${PROJECT_NAME}_ENABLE_DEB_FLAG)

IF(NOT MSVC)
	OPTION_WITH_DEFAULT( ${PROJECT_NAME}_COVERAGE "Build with coverage testing" OFF )
	MARK_AS_ADVANCED(${PROJECT_NAME}_COVERAGE)
ENDIF(NOT MSVC)

IF( NOT DEFINED ${PROJECT_NAME}_MULTITHREAD_LIBRARY)
	SET( ${PROJECT_NAME}_MULTITHREAD_LIBRARY "NONE" CACHE STRING "(values are: NONE TBB OPENMP)" )
ENDIF( NOT DEFINED ${PROJECT_NAME}_MULTITHREAD_LIBRARY)

IF( NOT "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" LESS 2.8 )
	SET_PROPERTY(CACHE ${PROJECT_NAME}_MULTITHREAD_LIBRARY PROPERTY STRINGS NONE TBB OPENMP)
ENDIF( NOT "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" LESS 2.8 )

OPTION( ${PROJECT_NAME}_MULTITHREAD_LIBRARY "Multithread library" ${${PROJECT_NAME}_MULTITHREAD_LIBRARY} )

IF( ${PROJECT_NAME}_MULTITHREAD_LIBRARY STREQUAL "TBB" )
	OPTION_WITH_DEFAULT( ${PROJECT_NAME}_TBB_MALLOC_SUPPORT "Use TBB for memory allocation" ON )
ENDIF( ${PROJECT_NAME}_MULTITHREAD_LIBRARY STREQUAL "TBB" )

IF( NOT DEFINED ${PROJECT_NAME}_INSTALL_PREFIX )
	IF( WIN32 )
		SET(${PROJECT_NAME}_INSTALL_PREFIX
			"c:/${PROJECT_NAME}-${${PROJECT_NAME}_VERSION}")
	ELSE( WIN32 )
		SET(${PROJECT_NAME}_INSTALL_PREFIX
			"/usr/local")
	ENDIF( WIN32 )
ENDIF( NOT DEFINED ${PROJECT_NAME}_INSTALL_PREFIX )

SET( ${PROJECT_NAME}_INSTALL_PREFIX ${${PROJECT_NAME}_INSTALL_PREFIX} CACHE
	PATH "Install prefix prepended to target to create install location" )
SET( CMAKE_INSTALL_PREFIX "${${PROJECT_NAME}_INSTALL_PREFIX}" CACHE INTERNAL "Prefix
	prepended to install directories if target destination is not absolute,
	immutable" FORCE )

IF( ${PROJECT_NAME}_BUILD_SHARED_LIB )
	SET( ${PROJECT_NAME}_LIBRARY_TYPE SHARED )
	SET( ${PROJECT_NAME}_BUILD_STATIC_LIB FALSE )
ELSE( ${PROJECT_NAME}_BUILD_SHARED_LIB )
	SET( ${PROJECT_NAME}_LIBRARY_TYPE STATIC )
	SET( ${PROJECT_NAME}_BUILD_STATIC_LIB TRUE )
	IF ( WIN32 )
		ADD_DEFINITIONS("-DHAVE_NO_DLL")
	ENDIF( WIN32 )
ENDIF( ${PROJECT_NAME}_BUILD_SHARED_LIB )

# MSVC specific options
IF(MSVC_IDE)
	IF (NOT DEFINED ${PROJECT_NAME}_USE_MSVC_EXPRESS )
		SET (${PROJECT_NAME}_USE_MSVC_EXPRESS OFF)
	ENDIF (NOT DEFINED ${PROJECT_NAME}_USE_MSVC_EXPRESS)
	OPTION( ${PROJECT_NAME}_USE_MSVC_EXPRESS "Use a Visual C++ express IDE"
		${${PROJECT_NAME}_USE_MSVC_EXPRESS} )
ENDIF(MSVC_IDE)

SET_DIRECTORY_PROPERTIES(PROPERTIES COMPILE_DEFINITIONS_RELEASE NDEBUG)
SET_DIRECTORY_PROPERTIES(PROPERTIES COMPILE_DEFINITIONS_MINSIZEREL NDEBUG)
SET_DIRECTORY_PROPERTIES(PROPERTIES COMPILE_DEFINITIONS_RELWITHDEBINFO  NDEBUG)

IF(${PROJECT_NAME}_ENABLE_DEB_FLAG)
  SET_DIRECTORY_PROPERTIES(PROPERTIES COMPILE_DEFINITIONS_DEBUG "DEB=1;_DEBUG")
ELSE ()
  SET_DIRECTORY_PROPERTIES(PROPERTIES COMPILE_DEFINITIONS_DEBUG "_DEBUG")
ENDIF (${PROJECT_NAME}_ENABLE_DEB_FLAG)

#
# Check components dependencies
#
SET(${PROJECT_NAME}_FOUNDATION TRUE)
IF(${PROJECT_NAME}_OCAF OR ${PROJECT_NAME}_DATAEXCHANGE OR ${PROJECT_NAME}_VISUALISATION OR ${PROJECT_NAME}_DRAW)
  SET(${PROJECT_NAME}_VISU_DEP TRUE)
ELSE(${PROJECT_NAME}_OCAF OR ${PROJECT_NAME}_DATAEXCHANGE OR ${PROJECT_NAME}_VISUALISATION OR ${PROJECT_NAME}_DRAW)
  SET(${PROJECT_NAME}_VISU_DEP FALSE)
ENDIF(${PROJECT_NAME}_OCAF OR ${PROJECT_NAME}_DATAEXCHANGE OR ${PROJECT_NAME}_VISUALISATION OR ${PROJECT_NAME}_DRAW)
IF(${PROJECT_NAME}_DISABLE_X11)
	SET(${PROJECT_NAME}_VISU_DEP FALSE)
ENDIF(${PROJECT_NAME}_DISABLE_X11)
IF(${PROJECT_NAME}_DISABLE_X11)
	SET(${PROJECT_NAME}_DRAW OFF CACHE BOOL "Build DRAWEXE" FORCE)
	SET(${PROJECT_NAME}_VISUALISATION OFF CACHE BOOL "Build visualisation component" FORCE)
ENDIF(${PROJECT_NAME}_DISABLE_X11)

IF(NOT ${PROJECT_NAME}_BUILD_SHARED_LIB AND ${PROJECT_NAME}_DRAW)
	SET(${PROJECT_NAME}_DRAW OFF CACHE BOOL "Build DRAWEXE" FORCE)
	MESSAGE("Warning : DRAW disabled when statically linking")
ENDIF(NOT ${PROJECT_NAME}_BUILD_SHARED_LIB AND ${PROJECT_NAME}_DRAW)

IF(${PROJECT_NAME}_DRAW AND NOT ${PROJECT_NAME}_DATAEXCHANGE)
	SET(${PROJECT_NAME}_DATAEXCHANGE ON CACHE BOOL "Build data exchange" FORCE)
ENDIF(${PROJECT_NAME}_DRAW AND NOT ${PROJECT_NAME}_DATAEXCHANGE)
IF(${PROJECT_NAME}_DATAEXCHANGE AND NOT ${PROJECT_NAME}_OCAF)
	SET(${PROJECT_NAME}_OCAF ON CACHE BOOL "Build application framework" FORCE)
ENDIF(${PROJECT_NAME}_DATAEXCHANGE AND NOT ${PROJECT_NAME}_OCAF)
IF(${PROJECT_NAME}_OCAF AND NOT ${PROJECT_NAME}_MODEL)
	SET(${PROJECT_NAME}_MODEL ON CACHE BOOL "Build model components" FORCE)
ENDIF(${PROJECT_NAME}_OCAF AND NOT ${PROJECT_NAME}_MODEL)
IF(${PROJECT_NAME}_VISUALISATION AND NOT ${PROJECT_NAME}_MODEL)
	SET(${PROJECT_NAME}_MODEL ON CACHE BOOL "Build model components" FORCE)
ENDIF(${PROJECT_NAME}_VISUALISATION AND NOT ${PROJECT_NAME}_MODEL)
IF(${PROJECT_NAME}_DRAW AND NOT ${PROJECT_NAME}_VISUALISATION)
	SET(${PROJECT_NAME}_VISUALISATION ON CACHE BOOL "Build visualisation component" FORCE)
ENDIF(${PROJECT_NAME}_DRAW AND NOT ${PROJECT_NAME}_VISUALISATION)

SET(INSTALL_STDRESOURCE_FILES)
SET(INSTALL_RESOURCE_FILES)
FILE(GLOB OS_TCL_SCRIPTS RELATIVE ${${PROJECT_NAME}_SOURCE_DIR} src/OS/*.tcl)
SET(INSTALL_RESOURCE_FILES ${INSTALL_RESOURCE_FILES}
	${OS_TCL_SCRIPTS}
	src/UnitsAPI/Lexi_Expr.dat
	src/UnitsAPI/Units.dat )
SET(INSTALL_STDRESOURCE_FILES ${INSTALL_STDRESOURCE_FILES}
	src/UnitsAPI/CurrentUnits
	src/UnitsAPI/MDTVBaseUnits
	src/UnitsAPI/MDTVCurrentUnits )

FIND_PACKAGE(Threads)
IF(${PROJECT_NAME}_MULTITHREAD_LIBRARY STREQUAL "TBB")
	FIND_PATH(TBB_INCLUDE_DIR tbb/tbb.h DOC "Location of header files for TBB (containing tbb/tbb.h)" ${CMAKE_SYSTEM_INCLUDE_PATH})
	IF(TBB_INCLUDE_DIR)
		IF(MSVC)
			IF(CMAKE_CL_64)
				SET(TBB_ARCH intel64)
			ELSE(CMAKE_CL_64)
				SET(TBB_ARCH ia32)
			ENDIF(CMAKE_CL_64)

=== test/CMakeLists.txt ===
#
# The OCE unittest framework use GoogleTest 1.6.0 (aka GTest)
# The GTest source code is available in the /test/gtest-1.6.0 folder
#
SET(GTEST_ROOT ${CMAKE_CURRENT_SOURCE_DIR}/gtest-1.6.0)

INCLUDE_DIRECTORIES(${GTEST_ROOT}/include ${GTEST_ROOT})
ADD_LIBRARY(gtest STATIC ${GTEST_ROOT}/src/gtest-all.cc )
TARGET_LINK_LIBRARIES(gtest ${CMAKE_THREAD_LIBS_INIT})

IF (USE_SOLUTION_FOLDERS)
	SET_TARGET_PROPERTIES(gtest PROPERTIES FOLDER "Tests" )
ENDIF(USE_SOLUTION_FOLDERS)

# Fix for MSVC11
IF(MSVC11)
  ADD_DEFINITIONS("-D_VARIADIC_MAX=10")
ENDIF()

# Copied from CMake
# Thanks to Daniel Blezek <blezek@gmail.com> for the GTEST_ADD_TESTS code
function(GTEST_ADD_TESTS executable extra_args)
    if(NOT ARGN)
        message(FATAL_ERROR "Missing ARGN: Read the documentation for GTEST_ADD_TESTS")
    endif()
    foreach(source ${ARGN})
        file(READ "${source}" contents)
        string(REGEX MATCHALL "TEST_?F?\\(([A-Za-z_0-9 ,]+)\\)" found_tests ${contents})
        foreach(hit ${found_tests})
            string(REGEX REPLACE ".*\\( *([A-Za-z_0-9]+), *([A-Za-z_0-9]+) *\\).*" "\\1.\\2" test_name ${hit})
            add_test(NAME ${test_name} COMMAND ${executable} --gtest_filter=${test_name} ${extra_args})
        endforeach()
    endforeach()
endfunction()

MACRO(ADD_OCE_TEST test_name libs)
  FILE(GLOB TEST_SOURCES *.cpp)
  SET(SOURCE_FILES ${TEST_SOURCES})
  ADD_EXECUTABLE(${test_name} ${SOURCE_FILES})
 
  IF (USE_SOLUTION_FOLDERS)
		SET_TARGET_PROPERTIES(${test_name} PROPERTIES FOLDER "Tests" )
  ENDIF(USE_SOLUTION_FOLDERS)
  
  FOREACH(LIB ${libs})
     TARGET_LINK_LIBRARIES(${test_name} ${LIB})
  ENDFOREACH(LIB ${libs})
  
  IF (${PROJECT_NAME}_COVERAGE)
    TARGET_LINK_LIBRARIES(${test_name} gcov gtest)
  ELSE (${PROJECT_NAME}_COVERAGE)
    TARGET_LINK_LIBRARIES(${test_name} gtest)
  ENDIF (${PROJECT_NAME}_COVERAGE)
  GTEST_ADD_TESTS(${test_name} "" ${SOURCE_FILES})
ENDMACRO(ADD_OCE_TEST test_name libs)

FILE(GLOB TEST_DIRECTORIES ./*_test gtest_sandbox)
SUBDIRS(${TEST_DIRECTORIES})

=== test/SortTools_test/CMakeLists.txt ===
ADD_OCE_TEST(sorttools_test "TKernel")

=== test/TDataXtd_test/CMakeLists.txt ===
IF (${PROJECT_NAME}_DATAEXCHANGE AND NOT ${PROJECT_NAME}_DISABLE_X11)
    # This test will dlopen FWOSPlugin, we link against it to ensure that
    # the library from the build tree is used.
    ADD_OCE_TEST(TDataXtd_test "TKCAF;TKXCAF;FWOSPlugin")
    FILE(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../src/StdResource" BuildPluginDir)
    # Semi-colon is a delimiter in SET_TESTS_PROPERTIES and have to be escaped
    STRING(REPLACE ";" "\\;" BuildPluginDir "${BuildPluginDir}")
    SET_TESTS_PROPERTIES(TDataXtdTestSuite.testPattern PROPERTIES ENVIRONMENT "CSF_PluginDefaults=${BuildPluginDir};CSF_PluginUserDefaults=${BuildPluginDir}")
ENDIF (${PROJECT_NAME}_DATAEXCHANGE AND NOT ${PROJECT_NAME}_DISABLE_X11)

=== test/UnitsAPI_test/CMakeLists.txt ===
SET_PROPERTY(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS SRC_CASROOT="${${PROJECT_NAME}_SOURCE_DIR}" SRC_RESOURCE="${${PROJECT_NAME}_SOURCE_DIR}/src/UnitsAPI")

ADD_OCE_TEST(units_test "TKernel")

=== adm/cmake/DRAWEXE/CMakeLists.txt ===
SET(TOOLKIT_APP DRAWEXE)

SET(TOOLKIT_APP_MODULES
	DRAWEXE
)
SET(TOOLKIT_APP_LIBS
	TKDraw
	TKMesh
	TKGeomAlgo
	TKTopAlgo
	TKHLR
	TKGeomBase
	TKG2d
	TKBRep
	TKMath
	TKG3d
	TKernel
	TKService
)

MESSAGE(STATUS "Processing application: ${TOOLKIT_APP} (${TOOLKIT_APP_MODULES})")
SET(TOOLKIT_APP_SOURCE_FILES)
FOREACH(MODULE ${TOOLKIT_APP_MODULES})
	# add all .cxx/*.c files or each module
	FILE(GLOB source_files
		${${PROJECT_NAME}_SOURCE_DIR}/src/${MODULE}/*.cxx
		${${PROJECT_NAME}_SOURCE_DIR}/src/${MODULE}/*.c
		${${PROJECT_NAME}_SOURCE_DIR}/drv/${MODULE}/*.cxx
		${${PROJECT_NAME}_SOURCE_DIR}/drv/${MODULE}/*.c)
	#MESSAGE(STATUS "${source_files}")
	FOREACH(module_source_file ${source_files})
		IF (WIN32)
			# For compilers under Windows a define must be set per file to correctly set the export macro
			SET_SOURCE_FILES_PROPERTIES(${module_source_file} PROPERTIES COMPILE_FLAGS "-D__${MODULE}_DLL")
		ENDIF(WIN32)
	ENDFOREACH(module_source_file ${source_files})

	# append these source files to the list of source files of the toolkit
	SET(TOOLKIT_APP_SOURCE_FILES ${TOOLKIT_APP_SOURCE_FILES} ${source_files})
	# required include paths
	INCLUDE_DIRECTORIES(${${PROJECT_NAME}_SOURCE_DIR}/src/${MODULE} ${${PROJECT_NAME}_SOURCE_DIR}/drv/${MODULE})
ENDFOREACH(MODULE ${TOOLKIT_APP_MODULES})

# Version info
IF(NOT ${PROJECT_NAME}_NO_LIBRARY_VERSION)
	IF(MSVC)
		SET(TOOLKIT_RESOURCES ${${PROJECT_NAME}_WIN32_RES_FILE})
		ADD_DEFINITIONS("-D${PROJECT_NAME}_VERSION_INFO_IS_EXE")
	ENDIF(MSVC)
ENDIF(NOT ${PROJECT_NAME}_NO_LIBRARY_VERSION)

ADD_EXECUTABLE(${TOOLKIT_APP} ${TOOLKIT_APP_SOURCE_FILES} ${TOOLKIT_RESOURCES} )

SET_TARGET_PROPERTIES_INSTALL_RPATH(${TOOLKIT_APP} "${${PROJECT_NAME}_INSTALL_LIB_DIR_RPATH};${${PROJECT_NAME}_INSTALL_PACKAGE_LIB_DIR_RPATH}")

IF(WIN32 AND (CMAKE_CONFIGURATION_TYPES OR NMAKE))
	SET_TARGET_PROPERTIES(${TOOLKIT_APP} PROPERTIES
		DEBUG_OUTPUT_NAME ${TOOLKIT_APP}${CMAKE_DEBUG_POSTFIX}
	)
ENDIF(WIN32 AND (CMAKE_CONFIGURATION_TYPES OR NMAKE))

# Set dependencies for thit ToolKit
LIST(REMOVE_DUPLICATES TOOLKIT_APP_LIBS)
TARGET_LINK_LIBRARIES(${TOOLKIT_APP} ${TOOLKIT_APP_LIBS} ${WIN32_LIBS})

#  Those are private libraries
INSTALL(TARGETS ${TOOLKIT_APP}
	RUNTIME DESTINATION ${${PROJECT_NAME}_INSTALL_BIN_DIR}         COMPONENT RuntimeLibraries
	LIBRARY DESTINATION ${${PROJECT_NAME}_INSTALL_PACKAGE_LIB_DIR} COMPONENT RuntimeLibraries
	ARCHIVE DESTINATION ${${PROJECT_NAME}_INSTALL_PACKAGE_LIB_DIR} COMPONENT Development
)

=== adm/cmake/TKCAF/CMakeLists.txt ===
SET(TOOLKIT TKCAF)

SET(TOOLKIT_MODULES
	TDataXtd
	TNaming
	TPrsStd
	AppStd
)
SET(TOOLKIT_DEPENDS
	TKernel
	TKBO
	TKLCAF
	TKG3d
	TKGeomBase
	TKV3d
	TKService
	TKMath
	TKCDF
	TKBRep
	TKG2d
	TKTopAlgo
	TKV2d
)

INCLUDE(../BuildToolkit.cmake)

=== adm/cmake/TKMesh/CMakeLists.txt ===
SET(TOOLKIT TKMesh)

SET(TOOLKIT_MODULES
	MeshDS
	BRepMesh
	MeshAlgo
	IntPoly
)
SET(TOOLKIT_DEPENDS
	TKMath
	TKernel
	TKG2d
	TKGeomBase
	TKBRep
	TKG3d
	TKGeomAlgo
	TKTopAlgo
)
IF(${PROJECT_NAME}_MULTITHREAD_LIBRARY STREQUAL "TBB" AND TBB_INCLUDE_DIR AND TBB_LIBRARY)
	ADD_DEFINITIONS(-DHAVE_TBB)
	SET(TOOLKIT_INCLUDE_DIRECTORIES ${TBB_INCLUDE_DIR})
	IF(CMAKE_CONFIGURATION_TYPES OR NMAKE)
		SET(TOOLKIT_LIBS_DEBUG ${TBB_LIBRARY_DEBUG})
		SET(TOOLKIT_LIBS_OPTIMIZED ${TBB_LIBRARY})
	ELSE(CMAKE_CONFIGURATION_TYPES OR NMAKE)
		SET(TOOLKIT_LIBS ${TBB_LIBRARY})
	ENDIF(CMAKE_CONFIGURATION_TYPES OR NMAKE)
ENDIF(${PROJECT_NAME}_MULTITHREAD_LIBRARY STREQUAL "TBB" AND TBB_INCLUDE_DIR AND TBB_LIBRARY)
IF(${PROJECT_NAME}_MULTITHREAD_LIBRARY STREQUAL "OPENMP" AND OPENMP_FOUND)
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
ENDIF(${PROJECT_NAME}_MULTITHREAD_LIBRARY STREQUAL "OPENMP" AND OPENMP_FOUND)

IF(${PROJECT_NAME}_DISABLE_BSPLINE_MESHER)
	SET_SOURCE_FILES_PROPERTIES( "${${PROJECT_NAME}_SOURCE_DIR}/src/BRepMesh/BRepMesh_FastDiscretFace.cxx" PROPERTIES COMPILE_DEFINITIONS ${PROJECT_NAME}_DISABLE_BSPLINE_MESHER )
ENDIF(${PROJECT_NAME}_DISABLE_BSPLINE_MESHER)

INCLUDE(../BuildToolkit.cmake)

=== adm/cmake/TKOpenGl/CMakeLists.txt ===
SET(TOOLKIT TKOpenGl)

SET(TOOLKIT_MODULES
	OpenGl
)
SET(TOOLKIT_DEPENDS
	TKService
	TKernel
	TKV3d
)

IF(CMAKE_CONFIGURATION_TYPES OR NMAKE)
	SET(TOOLKIT_LIBS ${OPENGL_LIBRARIES})
	SET(TOOLKIT_LIBS_DEBUG ${FTGL_LIBRARY_DEBUG} ${FREETYPE_LIBRARY_DEBUG})
	SET(TOOLKIT_LIBS_OPTIMIZED ${FTGL_LIBRARY} ${FREETYPE_LIBRARIES})
ELSE(CMAKE_CONFIGURATION_TYPES OR NMAKE)
	SET(TOOLKIT_LIBS ${OPENGL_LIBRARIES} ${FREETYPE_LIBRARIES} ${FTGL_LIBRARY})
ENDIF(CMAKE_CONFIGURATION_TYPES OR NMAKE)

SET(TOOLKIT_INCLUDE_DIRECTORIES ${OPENGL_INCLUDE_DIR} ${FREETYPE_INCLUDE_DIRS} ${FTGL_INCLUDE_DIR})

# OpenGl_Workspace::Print is available only on Windows
IF(WIN32 AND FREEIMAGE_LIBRARY AND ${PROJECT_NAME}_WITH_FREEIMAGE)
	ADD_DEFINITIONS(-DHAVE_FREEIMAGE)

	IF(CMAKE_CONFIGURATION_TYPES OR NMAKE)
		SET(TOOLKIT_LIBS_DEBUG ${TOOLKIT_LIBS_DEBUG} ${FREEIMAGEPLUS_LIBRARY_DEBUG} ${FREEIMAGE_LIBRARY_DEBUG})
		SET(TOOLKIT_LIBS_OPTIMIZED ${TOOLKIT_LIBS_OPTIMIZED} ${FREEIMAGEPLUS_LIBRARY} ${FREEIMAGE_LIBRARY})
	ELSE (CMAKE_CONFIGURATION_TYPES OR NMAKE)
		SET(TOOLKIT_LIBS ${TOOLKIT_LIBS} ${FREEIMAGEPLUS_LIBRARY} ${FREEIMAGE_LIBRARY})
	ENDIF(CMAKE_CONFIGURATION_TYPES OR NMAKE)

	SET(TOOLKIT_INCLUDE_DIRECTORIES ${TOOLKIT_INCLUDE_DIRECTORIES} ${FREEIMAGE_INCLUDE_DIR})
ENDIF(WIN32 AND FREEIMAGE_LIBRARY AND ${PROJECT_NAME}_WITH_FREEIMAGE)

IF(GL2PS_LIBRARY AND ${PROJECT_NAME}_WITH_GL2PS)
	ADD_DEFINITIONS(-DHAVE_GL2PS)

	IF(CMAKE_CONFIGURATION_TYPES OR NMAKE)
		SET(TOOLKIT_LIBS_DEBUG ${TOOLKIT_LIBS_DEBUG} ${GL2PS_LIBRARY_DEBUG})
		SET(TOOLKIT_LIBS_OPTIMIZED ${TOOLKIT_LIBS_OPTIMIZED} ${GL2PS_LIBRARY})
	ELSE (CMAKE_CONFIGURATION_TYPES OR NMAKE)
		SET(TOOLKIT_LIBS ${TOOLKIT_LIBS} ${GL2PS_LIBRARY})
	ENDIF(CMAKE_CONFIGURATION_TYPES OR NMAKE)

	SET(TOOLKIT_INCLUDE_DIRECTORIES ${TOOLKIT_INCLUDE_DIRECTORIES} ${GL2PS_INCLUDE_DIR})
ENDIF(GL2PS_LIBRARY AND ${PROJECT_NAME}_WITH_GL2PS)

IF(WIN32)
    LIST(APPEND TOOLKIT_LIBS vfw32)
ENDIF()

INCLUDE(../BuildToolkit.cmake)

IF(BORLAND AND BORLAND_VERSION_RS_XE2)
	# For bcc32 compiler v6.40 and up -x- compiler option must be passed as a compiler option
	# in stead of #pragma option -x- in code.
	foreach(source_file ${TOOLKIT_SOURCE_FILES} )
		if((source_file MATCHES "OpenGl_attri.cxx") OR
		   (source_file MATCHES "OpenGl_depthcue.cxx") OR
		   (source_file MATCHES "OpenGl_pick.cxx") OR
		   (source_file MATCHES "OpenGl_telem_util.cxx") OR
		   (source_file MATCHES "OpenGl_undefined.cxx") OR
		   (source_file MATCHES "OpenGl_view.cxx"))
			MESSAGE(STATUS "(bcc32) Disabling exceptions for ${source_file}.")
			set_source_files_properties("${source_file}" PROPERTIES COMPILE_FLAGS "-x-")
		endif()
	endforeach(source_file)
ENDIF(BORLAND AND BORLAND_VERSION_RS_XE2)

=== adm/cmake/TKQADraw/CMakeLists.txt ===
SET(TOOLKIT TKQADraw)

SET(TOOLKIT_MODULES
	DebugTools
	QABugs
	QADNaming
	QADraw
	QANCollection
	QANewBRepNaming
	QANewDBRepNaming
	QANewModTopOpe
)
SET(TOOLKIT_DEPENDS
	TKernel
	TKMath
	TKAdvTools
	TKG2d
	TKG3d
	TKGeomBase
	TKBRep
	TKGeomAlgo
	TKTopAlgo
	TKPrim
	TKShHealing
	TKBool
	TKFeat
	TKOffset
	TKSTL
	TKXSBase
	TKIGES
	TKXDESTEP
	TKCDF
	PTKernel
	TKLCAF
	TKCAF
	TKService
	TKV3d
	TKDraw
	TKViewerTest
	TKXSDRAW
	TKDCAF
)
SET(TOOLKIT_INCLUDE_DIRECTORIES ${TCL_INCLUDE_PATH})
SET(TOOLKIT_LIBS ${TCL_LIBRARY} ${CSF_gdi32_LIB} ${CSF_advapi32_LIB} ${CSF_user32_LIB})

IF(NOT WIN32)
	SET(TOOLKIT_INCLUDE_DIRECTORIES ${TOOLKIT_INCLUDE_DIRECTORIES} ${X11_X11_INCLUDE_PATH} ${TK_INCLUDE_PATH})
	SET(TOOLKIT_LIBS ${TOOLKIT_LIBS} ${TK_LIBRARY} ${X11_X11_LIB})
ENDIF(NOT WIN32)

SET(TOOLKIT_IS_PRIVATE TRUE)

INCLUDE(../BuildToolkit.cmake)

=== adm/cmake/TKService/CMakeLists.txt ===
SET(TOOLKIT TKService)

SET(TOOLKIT_MODULES
	AlienImage
	Aspect
	CGM
	Font
	Image
	MFT
	PS
	PlotMgt
	SelectBasics
	TColQuantity
	Viewer
)
IF (WIN32)
	SET(TOOLKIT_MODULES ${TOOLKIT_MODULES}
		InterfaceGraphic
		WNT
	)
ELSE(WIN32)
	IF (APPLE AND ${PROJECT_NAME}_OSX_USE_COCOA)
		SET(TOOLKIT_MODULES ${TOOLKIT_MODULES}
			ImageUtility
			Xw
			Cocoa
		)
		SET(TOOLKIT_LIBS ${X11_Xmu_LIB} ${X11_LIBRARIES} /System/Library/Frameworks/Cocoa.framework)
	ELSE(APPLE AND ${PROJECT_NAME}_OSX_USE_COCOA)
		SET(TOOLKIT_MODULES ${TOOLKIT_MODULES}
			ImageUtility
			Xw
		)
		SET(TOOLKIT_LIBS ${X11_Xmu_LIB} ${X11_LIBRARIES})
	ENDIF(APPLE AND ${PROJECT_NAME}_OSX_USE_COCOA)
ENDIF(WIN32)
SET(TOOLKIT_DEPENDS TKMath TKernel)

IF(FREEIMAGE_LIBRARY AND ${PROJECT_NAME}_WITH_FREEIMAGE)
	ADD_DEFINITIONS(-DHAVE_FREEIMAGE)

	IF(CMAKE_CONFIGURATION_TYPES OR NMAKE)
		SET(TOOLKIT_LIBS_DEBUG ${TOOLKIT_LIBS_DEBUG} ${FREEIMAGE_LIBRARY_DEBUG})
		SET(TOOLKIT_LIBS_OPTIMIZED ${TOOLKIT_LIBS_OPTIMIZED} ${FREEIMAGE_LIBRARY})
	ELSE (CMAKE_CONFIGURATION_TYPES OR NMAKE)
		SET(TOOLKIT_LIBS ${TOOLKIT_LIBS} ${FREEIMAGE_LIBRARY})
	ENDIF(CMAKE_CONFIGURATION_TYPES OR NMAKE)

	SET(TOOLKIT_INCLUDE_DIRECTORIES ${TOOLKIT_INCLUDE_DIRECTORIES} ${FREEIMAGE_INCLUDE_DIR})
ENDIF(FREEIMAGE_LIBRARY AND ${PROJECT_NAME}_WITH_FREEIMAGE)

INCLUDE(../BuildToolkit.cmake)

IF(BORLAND)
	# cgmobin.c, cgmochar.c and cgmotext.c need __STDC__=1 define in order to build for bcc32.
	foreach(source_file ${TOOLKIT_SOURCE_FILES} )
		if ((source_file MATCHES "cgmobin.c") OR
			(source_file MATCHES "cgmochar.c") OR
			(source_file MATCHES "cgmotext.c"))
			set_source_files_properties("${source_file}" PROPERTIES COMPILE_DEFINITIONS "__STDC__=1")
		endif()
	endforeach(source_file)
ENDIF(BORLAND)

=== adm/cmake/TKViewerTest/CMakeLists.txt ===
SET(TOOLKIT TKViewerTest)

SET(TOOLKIT_MODULES
	Viewer2dTest
	ViewerTest
)
SET(TOOLKIT_DEPENDS
	TKernel
	TKBool
	TKG2d
	TKOffset
	TKG3d
	TKGeomBase
	TKTopAlgo
	TKV2d
	TKV3d
	TKDraw
	TKOpenGl
	TKService
	TKMath
	TKBRep
	TKMesh
	TKGeomAlgo
	TKFillet
	TKTopTest
	TKHLR
	TKVoxel
	TKNIS
	TKPrim
)

IF(WIN32)
	SET(TOOLKIT_LIBS ${CSF_user32_LIB} ${CSF_gdi32_LIB})
ELSE(WIN32)
	SET(TOOLKIT_INCLUDE_DIRECTORIES ${X11_X11_INCLUDE_PATH} ${TK_INCLUDE_PATH} ${OPENGL_INCLUDE_DIR})
	SET(TOOLKIT_LIBS ${TK_LIBRARY} ${X11_X11_LIB})
ENDIF(WIN32)

SET(TOOLKIT_IS_PRIVATE TRUE)

INCLUDE(../BuildToolkit.cmake)

=== debian/changelog ===
oce (0.12-3) unstable; urgency=low

  * Uploaded into unstable
  * debian/watch: Updated by Bart Martens, thanks.

 -- Denis Barbier <barbier@debian.org>  Wed, 10 Jul 2013 23:59:31 +0200

oce (0.12-2) experimental; urgency=low

  * debian/rules: Set DART_TESTING_TIMEOUT to 3600 to
    fix build failures on mips.

 -- Denis Barbier <barbier@debian.org>  Fri, 14 Jun 2013 21:57:39 +0200

oce (0.12-1) experimental; urgency=low

  * New upstream version, SONAME bumped.
  * debian/control: Append "-b debian" to Vcs-Git field.
  * debian/control: Bump Standards-Version to 3.9.4.
  * debian/patches/port-memalign.patch: Drop patch,
    it has been incorporated upstream.
  * debian/patches/fix-Hurd.patch: New patch, to fix test
    failures on Hurd.

 -- Denis Barbier <barbier@debian.org>  Wed, 13 Mar 2013 21:16:50 +0100

oce (0.11-2) experimental; urgency=low

  * debian/patches/port-memalign.patch: New patch to fix build
    failures, mm_malloc.h is available only on x86 and amd64.

 -- Denis Barbier <barbier@debian.org>  Sat, 15 Dec 2012 21:08:50 +0100

oce (0.11-1) experimental; urgency=low

  * New upstream version, SONAME bumped.
  * debian/patches/add-TKQADraw.patch: Drop patch, incorporated upstream.

 -- Denis Barbier <barbier@debian.org>  Wed, 12 Dec 2012 22:02:12 +0100

oce (0.10-3) experimental; urgency=low

  * debian/rules: Force parallel build.
  * Move usr/include/oce/oce_build_config.defs into usr/include/oce/<triplet>/
    so that liboce-foundation-dev packages are coinstallable.
  * Split installed CMake targets file so that each -dev package
    ships a targets file with the libraries it contains.  Currently
    one must install all *-dev packages because otherwise CMake
    complains about missing files referenced from an imported target.
  * Flag *-dev packages as Multi-Arch: same and not foreign.

 -- Denis Barbier <barbier@debian.org>  Sun, 05 Aug 2012 09:10:56 +0200

oce (0.10-2) experimental; urgency=low

  * debian/control: Version liboce*-dev dependencies.
    Patch and report by Julien Cristau, thanks.  (Closes: #678403)
  * Add support for multiarch.  (Closes: #682866)
    All liboce-*-dev packages are now Arch: any.
    Add multiarch dirs to CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES
    so that multiarch directory is seen as a system library and
    not added into RPATH.  See #683484.
  * Allow using plugins when liboce-ocaf-lite-dev is not
    installed.  (Closes: #683374)

 -- Denis Barbier <barbier@debian.org>  Wed, 01 Aug 2012 01:12:32 +0200

oce (0.10-1) experimental; urgency=low

  [ Denis Barbier ]
  * New upstream version, based on OCCT 6.5.3.
  * debian/control: Bump sonames.
  * debian/patches/ftbfs-alpha.patch: Drop patch,
    it has been incorporated upstream.
  * debian/control: liboce-foundation-dev contains
    arch-dependent files, it must be declared
    Architecture: any (Closes: 676776)
    Thanks Sandro Knauß for the report.
  * debian/patches/add-TKQADraw.patch: New patch,
    add the TKQADraw module which had been forgotten
    in OCE 0.10.
  * debian/rules: Call dpkg-buildflags to set build flags.

 -- Denis Barbier <barbier@debian.org>  Sat, 09 Jun 2012 11:35:27 +0200

oce (0.9.1-2) unstable; urgency=low

  [ Denis Barbier ]
  * Add missing header files LDOMBasicString.hxx, LDOMParser.hxx
    and LDOMString.hxx into liboce-ocaf-lite-dev.  Closes: #674021
    Thanks to Julien Cristau for the report.
  * Add myself to Uploaders.

 -- Denis Barbier <barbier@debian.org>  Sun, 27 May 2012 08:21:17 +0200

=== debian/control ===
Source: oce
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>, Denis Barbier <barbier@debian.org>
Standards-Version: 3.9.4
Build-Depends: debhelper (>= 9), quilt, cmake,
 libx11-dev, libxmu-dev, libxext-dev, tcl8.5-dev, tk8.5-dev,
 libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev,
 libftgl-dev, libgl2ps-dev
Homepage: https://github.com/tpaviot/oce/wiki
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/oce.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/oce.git -b debian

Package: liboce-foundation6
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform shared library
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package is based on OCE, OpenCASCADE Community Edition, which is
 maintained by a community of developers, and not by OpenCASCADE SAS.
 .
 This package contains foundation classes which provide a variety of
 general-purpose services such as automated management of heap memory,
 exception handling, classes for manipulating aggregates of data, basic
 math tools.
 .
 This package contains the following shared libraries:
   TKernel TKMath TKAdvTools

Package: liboce-modeling6
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform shared library
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package is based on OCE, OpenCASCADE Community Edition, which is
 maintained by a community of developers, and not by OpenCASCADE SAS.
 .
 This package supplies data structures to represent 2D and 3D geometric models,
 as well as topological and geometrical algorithms.
 .
 This package contains the following shared libraries:
   TKG2d TKG3d TKGeomBase TKBRep TKGeomAlgo TKTopAlgo TKPrim TKBO TKHLR
   TKMesh TKShHealing TKXMesh TKBool TKFillet TKFeat TKOffset TKSTL
   TKXSBase TKSTEPBase TKIGES TKSTEPAttr TKSTEP209 TKSTEP

Package: liboce-visualization6
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform shared library
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package is based on OCE, OpenCASCADE Community Edition, which is
 maintained by a community of developers, and not by OpenCASCADE SAS.
 .
 This package provides services for displaying 2D and 3D graphics.
 .
 This package contains the following shared libraries:
   TKService TKV2d TKV3d TKOpenGl TKMeshVS TKNIS TKVRML TKVoxel

Package: liboce-ocaf-lite6
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform shared library
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package is based on OCE, OpenCASCADE Community Edition, which is
 maintained by a community of developers, and not by OpenCASCADE SAS.
 .
 This package is part of the OpenCASCADE Application Framework, it
 provides shared libraries which have no dependency against X11.
 .
 This package contains the following shared libraries:
   TKCDF PTKernel TKLCAF FWOSPlugin TKPShape TKBinL TKXmlL
   TKPLCAF TKTObj TKShapeSchema TKStdLSchema

Package: liboce-ocaf6
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform shared library
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package is based on OCE, OpenCASCADE Community Edition, which is
 maintained by a community of developers, and not by OpenCASCADE SAS.
 .
 This package provides OpenCASCADE Application Framework services and 
 support for data exchange.
 .
 This package contains the following shared libraries:
   TKCAF TKBin TKXml TKPCAF TKBinTObj TKXmlTObj TKStdSchema
   TKXCAF TKXCAFSchema TKXmlXCAF TKBinXCAF TKXDEIGES TKXDESTEP

Package: oce-draw
Architecture: any
Section: science
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: opencascade-draw
Conflicts: opencascade-draw
Description: OpenCASCADE Community Edition CAE platform shared library
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package is based on OCE, OpenCASCADE Community Edition, which is
 maintained by a community of developers, and not by OpenCASCADE SAS.
 .
 This package contains the DRAW test harness.

Package: liboce-foundation-dev
Architecture: any
Section: libdevel
Depends: liboce-foundation6 (>= ${source:Upstream-Version}), liboce-foundation6 (<< ${source:Upstream-Version}+1~),
         ${misc:Depends}
Replaces: libopencascade-foundation-dev
Conflicts: libopencascade-foundation-dev
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform library development files
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 liboce-foundation6.

Package: liboce-modeling-dev
Architecture: any
Section: libdevel
Depends: liboce-foundation-dev (>= ${source:Upstream-Version}), liboce-foundation-dev (<< ${source:Upstream-Version}+1~),
         liboce-modeling6 (>= ${source:Upstream-Version}), liboce-modeling6 (<< ${source:Upstream-Version}+1~),
         ${misc:Depends}
Replaces: libopencascade-modeling-dev
Conflicts: libopencascade-modeling-dev
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform library development files
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 liboce-modeling6.

Package: liboce-ocaf-lite-dev
Architecture: any
Section: libdevel
Depends: liboce-foundation-dev (>= ${source:Upstream-Version}), liboce-foundation-dev (<< ${source:Upstream-Version}+1~),
         liboce-modeling-dev (>= ${source:Upstream-Version}), liboce-modeling-dev (<< ${source:Upstream-Version}+1~),
         liboce-ocaf-lite6 (>= ${source:Upstream-Version}), liboce-ocaf-lite6 (<< ${source:Upstream-Version}+1~),
         ${misc:Depends}
Replaces: libopencascade-ocaf-lite-dev
Conflicts: libopencascade-ocaf-lite-dev
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform library development files
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 liboce-ocaf-lite6.

Package: liboce-ocaf-dev
Architecture: any
Section: libdevel
Depends: liboce-foundation-dev (>= ${source:Upstream-Version}), liboce-foundation-dev (<< ${source:Upstream-Version}+1~),
         liboce-modeling-dev (>= ${source:Upstream-Version}), liboce-modeling-dev (<< ${source:Upstream-Version}+1~),
         liboce-ocaf-lite-dev (>= ${source:Upstream-Version}), liboce-ocaf-lite-dev (<< ${source:Upstream-Version}+1~),
         liboce-ocaf6 (>= ${source:Upstream-Version}), liboce-ocaf6 (<< ${source:Upstream-Version}+1~),
         ${misc:Depends}
Replaces: libopencascade-ocaf-dev
Conflicts: libopencascade-ocaf-dev
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform library development files
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 liboce-ocaf6.

Package: liboce-visualization-dev
Architecture: any
Section: libdevel
Depends: liboce-foundation-dev (>= ${source:Upstream-Version}), liboce-foundation-dev (<< ${source:Upstream-Version}+1~),
         liboce-modeling-dev (>= ${source:Upstream-Version}), liboce-modeling-dev (<< ${source:Upstream-Version}+1~),
         liboce-ocaf-lite-dev (>= ${source:Upstream-Version}), liboce-ocaf-lite-dev (<< ${source:Upstream-Version}+1~),
         liboce-visualization6 (>= ${source:Upstream-Version}), liboce-visualization6 (<< ${source:Upstream-Version}+1~),
         ${misc:Depends}
Replaces: libopencascade-ocaf-lite-dev
Conflicts: libopencascade-ocaf-lite-dev
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform library development files
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 liboce-visualization6.

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS   := $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifeq ($(findstring parallel=,$(DEB_BUILD_OPTIONS)),)
	export DEB_BUILD_OPTIONS+=parallel=$(shell getconf _NPROCESSORS_ONLN)
endif

%:
	dh $@ --buildsystem=cmake --parallel --with quilt

override_dh_auto_configure:
	# See in debian/patches/split-export.patch why we must ignore cmake return value
	-dh_auto_configure -- \
        -DOCE_BUILD_SHARED_LIB:BOOL=ON \
        -DOCE_TESTING:BOOL=ON \
        -DOCE_BUILD_TYPE:STRING=RelWithDebInfo \
        -DOCE_INSTALL_PREFIX:PATH=/usr \
        -DOCE_INSTALL_LIB_DIR:PATH=lib/$(DEB_HOST_MULTIARCH) \
        -DOCE_INSTALL_CMAKE_DATA_DIR:PATH=lib/$(DEB_HOST_MULTIARCH)/oce-0.12 \
        -DOCE_DRAW:BOOL=ON \
        -DOCE_RPATH_FILTER_SYSTEM_PATHS:BOOL=ON \
        -DCMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES:STRING='/lib/$(DEB_HOST_MULTIARCH);/usr/lib/$(DEB_HOST_MULTIARCH)' \
        -DCMAKE_C_FLAGS_RELWITHDEBINFO:STRING='$(CFLAGS)' \
        -DCMAKE_CXX_FLAGS_RELWITHDEBINFO:STRING='$(CXXFLAGS)' \
        -DCMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(LDFLAGS)' \
        -DCMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(LDFLAGS)' \
        -DOCE_MULTITHREAD_LIBRARY:STRING=NONE \
        -DOCE_WITH_FREEIMAGE:BOOL=ON \
        -DOCE_WITH_GL2PS:BOOL=ON \
        -DDART_TESTING_TIMEOUT:STRING='3600'

override_dh_auto_install:
	dh_auto_install
	-mkdir debian/tmp/usr/include/oce/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/include/oce/oce_build_config.defs debian/tmp/usr/include/oce/$(DEB_HOST_MULTIARCH)/oce_build_config.defs
	# Improve integration in Debian desktop
	install -d debian/tmp/usr/share/applications
	cp -p debian/oce-draw.desktop debian/tmp/usr/share/applications/
	install -d debian/tmp/usr/share/pixmaps
	cp -p debian/occ-icon-32.xpm debian/tmp/usr/share/pixmaps/
	install -d debian/tmp/usr/share/man/man1
	# Install manual page
	cp -p debian/DRAWEXE.1 debian/tmp/usr/share/man/man1/
	find debian/tmp/usr/share -name FILES -exec rm -f {} \;

override_dh_install:
	dh_install --list-missing
	rm -rf debian/oce-draw/usr/include
	# Allow using plugins when liboce-ocaf-lite-dev is not installed, see #683374
	sed -i -e 's/FWOSPlugin$$/&-6/' debian/liboce-foundation6/usr/share/oce-*/src/StdResource/Plugin
	ln -sf libFWOSPlugin.so.6 debian/liboce-ocaf-lite6/usr/lib/$(DEB_HOST_MULTIARCH)/libFWOSPlugin-6.so

override_dh_makeshlibs:
	dh_makeshlibs -Noce-draw
